% Ajuste por cuadrados minimos con errores en ambas variables
% y = a + b*x basado en el paper de Cecchi(1990) y luego comentado por Moreno and Bruzzone (1993)

clear all;
close all;
clc;

global x y dx dy

datos = dlmread('pearson.txt');
x = datos(:,1);
y = datos(:,2);
dx = datos(:,3);
dy = datos(:,4);
%--------------------------------------------------------------------------
%--------------------------------------------------------------------------
% Ajuste y = ax + b con errores en ambas variables

partida = [6 -0.5];
options = optimset('display','final','MaxFunEvals',100000,'MaxIter',5000,'TolX',1e-8,'TolFun',1e-8);
[coef, minfx2] = fminsearch(@funcion,partida,options);

a = coef(1);
b = coef(2);

% Calculo el error de los coeficientes
d = (y - a - b*x);
w = (1./( dy.^2 + (b*dx).^2 ));
F = x + 2*b*d.*w.*dx.^2;
A = -sum(w);
B = -sum(w.*F);
C = -sum(w.*F.^2 - d.^2.*w.^2.*dx.^2);
D = A.*C - B.^2;

dadx = w.*( b*C + B.*( d - b*F ))/D;
dady = w.*( B.*F - C)/D;
dbdx = -w.*( b*B + A.*( d - b*F ))/D;
dbdy = w.*(B - A.*F)/D;

Sa = sqrt(sum( (dadx.*dx).^2 + (dady.*dy).^2 ));
Sb = sqrt(sum( (dbdx.*dx).^2 + (dbdy.*dy).^2 ));

hold on;
grid on;
box;
g2a = ploterr(x,y,dx,dy,'.');
set(g2a,'MarkerSize',16,'LineWidth',1.5);

X = x(1)-1:(x(end)-x(1))/50:x(end)+1;
Y = a + b*X;
g2b = plot(X,Y,'r');
set(g2b,'LineWidth',2);
title(['a = ',num2str(a),' \pm ',num2str(Sa),' -- b = ',num2str(b),' \pm ',num2str(Sb)],'FontSize',16)
